import { Component } from 'react'
import Taro from '@tarojs/taro'
import { userLogin } from './services/user'
import store, { StoreRoot } from './store'

import './app.less'

class App extends Component {



  componentDidMount() {
    const { signIn } = store.getModel('useFoo').getState()

    Taro.login({
      success: (res) => {
        const { code } = res;
        signIn({ code })
      }
    }).catch(e => {
      Taro.showToast({
        title: '网络异常, 请退出重试',
        icon: 'none',
      })
    })




  }

  componentDidShow() { }

  componentDidHide() { }

  componentDidCatchError() { }

  // this.props.children 是将要会渲染的页面
  render() {
    return (
      <StoreRoot>
        {this.props.children}
      </StoreRoot>
    )
  }
}

export default App
