
import { useEffect, useMemo, useRef, useState } from 'react';
import Taro from '@tarojs/taro';
import { View } from '@tarojs/components'
import Counter from '@/components/Counter'
import { Button } from '@antmjs/vantui';
import useInterval from '@/hooks/useInterval';
import { score } from '../../services/user';

import TopBar from './components/TopBar'
import useCountDown from './hooks/useCountDown';
import useShake from './hooks/useShake';
import { useModel } from '../../store'

import './index.less'

const IndexPage = (props) => {
  const modRef = useRef('ready')

  const [num, setNum] = useState(0)
  const [btnDisable, setBtnDisable] = useState(false)
  const { getAvatar, sessionKey, person } = useModel('useFoo')
  const [buttonTitle, setbuttonTitle] = useState(true)
  console.log("🚀 ~ file: index.jsx ~ line 23 ~ IndexPage ~ person", person)

  // 定时器
  const [add2TickerList] = useInterval(1400)

  // 倒计时
  const [count, countFn, startCount] = useCountDown();
  useMemo(() => add2TickerList(countFn), [])

  // 摇一摇
  const [times, startShake, onShakeEnd] = useShake()

  onShakeEnd(() => {
    // 摇一摇结束

    Taro.showToast({
      title: '游戏结束',
      icon: 'none',
      duration: 2000


    }).then(e => {
      score({ personId: person?.personId, createDate: person?.createDate, score: times }).then(e => {
        modRef.current = 'ready'
        setBtnDisable(false)
        console.log(" 摇一摇结束")
        setbuttonTitle(false)


      })

    })

    // do something
  })



  const handleStart = () => {

    if (!person?.avatar) {
      Taro.getUserProfile({
        lang: 'zh_CN',
        desc: "获取你的昵称、头像、地区及性别",
        success: (res) => {
          const data = {
            encryptedData: res.encryptedData,
            iv: res.iv,
            rawData: res.rawData,
            sessionKey: sessionKey,
            signature: res.signature
          }
          getAvatar(data)
          Taro.showToast({
            title: '授权头像成功',
            icon: 'success',
            duration: 2000
          })


        },
        fail: () => {
          //拒绝授权
          console.error("拒绝了请求");
          return;
        }
      })
    } else {

      modRef.current = 'countdown'
      startCount(3)
      setBtnDisable(true)
    }







  }

  useEffect(() => {
    if (modRef.current === 'countdown') {
      setNum(count)
    } else {
      setNum(times)
    }
  }, [count, times])

  useEffect(() => {
    if (modRef.current === 'countdown') {
      if (count === 0) {
        modRef.current = 'shake'
        startShake()
      }
    }
  }, [count])

  return (
    <View className='page-wrapper page-index'>
      <Counter className='shake-bg' value={num} />
      <TopBar />
      <View style={{ width: '80vw', position: 'fixed', bottom: '2em', left: '10vw' }} >
        <Button
          block
          round
          color='linear-gradient(to right, rgb(255, 96, 52), rgb(238, 10, 36))'
          onClick={handleStart}
          disabled={btnDisable}
        >{buttonTitle ? '开始游戏' : '继续游戏'}</Button>
      </View>
    </View>
  )
}

export default IndexPage;
