import { View, Text, Image, Canvas } from '@tarojs/components'
import React, { useMemo, useState, useEffect } from 'react'
import Taro from '@tarojs/taro'
import CanvasPart from '@/components/CanvasParty'
import numFormat from '@/utils/numFormat'

import Topic1 from './components/Topic1'
import TopicItem from './components/TopicItem'
import { scoreTop } from '../../services/user'

import './style.less'


export default (props) => {

  const [list, setList] = useState([])
  const menuBtnBounding = useMemo(() => Taro.getMenuButtonBoundingClientRect(), [])
  const style = useMemo(() => {
    const top = menuBtnBounding.height + menuBtnBounding.top

    return {
      paddingTop: `${top}px`
    }
  }, [menuBtnBounding.height, menuBtnBounding.top])

  // const [first, leftData] = useMemo(() => {
  //   const [f, ...l] = list || []
  //   return [f, l]
  // }, [list])


  useEffect(() => {
    scoreTop().then(e => {
      setList(e)
    })

  }, [])



  return (
    <View className='page-wrapper page-topListCopy' style={style}>

      <Topic1 list={list} />
      <View className='TopConten-box'>
        <View className='title-name'>排名</View>
        <View className='title-name'>用户</View>
        <View className='title-name'>昵称</View>
        <View className='title-name'>次数</View>
      </View>
      {/* #B99764  铜牌
      #C9C9CF */}

      <scroll-view scrollY style={{ height: '100%', marginTop: '1em' }}>



        {
          list.map((item, index) => {
            console.log("🚀 ~ file: index.jsx ~ line 60 ~ list.map ~ index", index)

            const styles = {
              backgroundColor: '#C9C9CF',
              animationDelay: `${100 * index + 80}ms`
            }
            if (index >= 1) {
              return (

                <View key={index} className='UserContent-box' style={styles}>
                  <View className='topsum'>{index + 1}</View>
                  <Image style={{
                    width: '47px',
                    height: '47px',
                    borderRadius: '50%',
                    position: 'absolute',
                    left: '8.3em'

                  }} src={item.avatar}
                  />
                  <View className='topNumber-name'>
                    {item.nickName}
                  </View>
                  <View className='topNumber-text'>
                    {numFormat(item.score)}

                  </View>
                </View>
              )
            }


          })
        }
      </scroll-view>




    </View>
  )
}
