import { useState } from "react"
import Taro, { stopDeviceMotionListening } from '@tarojs/taro'
import { userLogin, authAvatar } from '../../services/user'




export default function useUser() {
  const [user, setUser] = useState({})
  const [person, setPerson] = useState()
  const [sessionKey, setSessionKey] = useState()



  const signIn = (params) => {
    userLogin(params.code).then((res) => {
      const { person: taPerson, skey, token } = res;
      setPerson(taPerson);
      setSessionKey(skey);

      Taro.setStorage({ key: 'token', data: token })
    })
  }

  const signOut = () => {
    // xxx
  }

  const getAvatar = (data) => {
    return authAvatar(data).then((res) => {
      setPerson(res);
    })
  }

  return {
    user,
    person,
    sessionKey,

    signIn,
    signOut,
    getAvatar,

  }
}
